=== debian/changelog ===
ospray (3.2.0-2) unstable; urgency=medium

  * Team Upload
  * Fix Team name
  * Add Salsa-CI config
  * Bump standard version to 4.7.2

 -- Alexandre Detiste <tchet@debian.org>  Sat, 11 Oct 2025 14:29:40 +0200

ospray (3.2.0-1) unstable; urgency=medium

  * New upstream release

 -- Francois Mazen <mzf@debian.org>  Sun, 29 Sep 2024 21:04:12 +0200

ospray (3.1.0-2) unstable; urgency=medium

  * Add missing copyrights
  * Bump standard version to 4.7.0

 -- Francois Mazen <mzf@debian.org>  Thu, 05 Sep 2024 21:16:12 +0200
