=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DOSPRAY_ENABLE_VOLUMES=OFF \
		-DOSPRAY_ENABLE_APPS=OFF

execute_after_dh_auto_install:
	# Remove empty directories in usr/include before install
	find debian/tmp/usr/include -type d -empty -delete
