=== debian/tests/control ===
Tests: test-libospray
Depends: libospray-dev, cmake, build-essential
